Subject: Re: bug#48444: 28.0.50; package.el wrong path for package-gnupghome-dir on win10

From: Eli Zaretskii <[email-masked]>
Date: Sat, 15 May 2021 19:04:43 +0300

> From: [email-masked]
> Date: Sat, 15 May 2021 17:07:58 +0200
> 
> Recipe: start Emacs started -Q flag from mingw64 bash prompt (msys2).
> 
> I have freshly installed msys2 + deps + Emacs 28.0.50 from
> master. Package installation failes due to some problem with how path for
> `package-gnupghome-dir' is interpreted/setuped. Don't know really,
> haven't investigated myself. Paths originally evals to:
> "c:/Users/arthu/.emacs.d/elpa/gnupg" which is correct, but somehow
> Emacs/package.el does not understands it or pass it wrongly to gpg;
> since gpg ends up with this path:
> 
> /c/Users/arthu/.emacs.d/c:/Users/arthu/.emacs.d/elpa/gnupg/pubring.kbx.
> 
> I am pasting the error I get when trying go install a package:
> 
> Failed to verify signature archive-contents.sig:
> No public key for 066DAFCB81E42C40 created at 2021-05-13T23:10:01+0200 using RSA
> Command output:
> gpg: keyblock resource '/c/Users/arthu/.emacs.d/c:/Users/arthu/.emacs.d/elpa/gnupg/pubring.kbx': No such file or directory
> gpg: Signature made Thu May 13 23:10:01 2021    
> gpg:                using RSA key C433554766D3DDC64221BFAA066DAFCB81E42C40
> gpg: Can't check signature: No public key
> 
> If I setq path to use Unix prefix '/c/...' instead of 'C:/...' things
> seems to work:
> 
> (setq package-gnupghome-dir "/c/Users/arthu/.emacs.d/elpa/gnupg")
> 
> Not sure if it is Emacs bug or on gpg side, but it is an issue.

Looks like you are mixing MSYS2 executables and native Windows
(a.k.a. "MinGW") executables, and that is at least part of the problem
if not all of it.

You should only use MinGW executables with a MinGW Emacs.